# initial color
hue = 201
saturation = 95
lightness = 57

# our layer
square = new Layer
	size: 250
	borderRadius: 9
	backgroundColor: "hsl(#{hue}, #{saturation}, #{lightness})"
	point: Align.center
	shadowColor: "rgba(153,153,153,1)"
	shadowY: 16
	shadowBlur: 32

square.animationOptions =
	curve: "spring(300, 20)"

# color label
label = new TextLayer
	width: 200
	height: 46
	borderRadius: 23
	backgroundColor: "rgba(0,0,0,0.5)"
	point: Align.center
	parent: square
	text: square.backgroundColor.toHslString()
	color: "#fff"
	fontSize: 17
	textAlign: Align.center
	lineHeight: 2.8

# Start of pan movement
square.onPanStart ->
	this.animate
		scale: 0.94
		shadowColor: "rgba(153,153,153,0)"

# While panning
square.onPan ->
	# The panning direction (up, down, left, right)
	direction = event.offsetDirection
	
	if direction is "up" or direction is "down"
		hue += event.delta.y
	else if direction is "left" or direction is "right"
		lightness += event.delta.x
	
	# giving the layer a new backgroundColor
	this.backgroundColor = "hsl(#{hue}, #{saturation}, #{lightness})"
	label.text = this.backgroundColor.toHslString()

# Animate back on PanEnd
square.onPanEnd ->
	this.animate
		scale: 1
		shadowColor: "rgba(153,153,153,1)"
